SystemOrganization addCategory: #homeWork!
SystemOrganization addCategory: #'homeWork-tests'!
SystemOrganization addCategory: #'homeWork-version1'!
SystemOrganization addCategory: #'homeWork-version2'!

Object subclass: #ApplicableDrawers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version2'!

!ApplicableDrawers commentStamp: 'allerschema 1/3/2019 11:25' prior: 0!
I collect Roassal drawers applicable on a specific type of object.!

!ApplicableDrawers methodsFor: 'utility' stamp: 'allerschema 1/7/2019 15:45'!
drawersFor: aType
	^ HWRoassalDrawer selectSubclasses: [ :drawerClass | drawerClass isApplicableOn: aType ]! !

Object subclass: #DrawConfig
	instanceVariableNames: 'type selectedDrawer applicableDrawers zoom center'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version2'!

!DrawConfig commentStamp: 'allerschema 1/3/2019 11:57' prior: 0!
My I store user config !

!DrawConfig methodsFor: 'accessing' stamp: 'allezschema 1/5/2019 18:03'!
applicableDrawers
	^self
		getDrawers.
	! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:30'!
center
	^ center! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:30'!
center: anObject
	center := anObject! !

!DrawConfig methodsFor: 'utilities' stamp: 'allerschema 1/3/2019 11:28'!
drawers
applicableDrawers drawersFor: type.! !

!DrawConfig methodsFor: 'utilities' stamp: 'allezschema 1/5/2019 18:03'!
getDrawers
	^ApplicableDrawers
		new
		drawersFor: type! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:29'!
selectedDrawer
	^ selectedDrawer! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:29'!
selectedDrawer: anObject
	selectedDrawer := anObject! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:29'!
type
	^ type! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:29'!
type: anObject
	type := anObject! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:30'!
zoom
	^ zoom! !

!DrawConfig methodsFor: 'accessing' stamp: 'allerschema 1/3/2019 11:30'!
zoom: anObject
	zoom := anObject! !

Object subclass: #HWMooseQueryHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version2'!

!HWMooseQueryHandler methodsFor: 'as yet unclassified' stamp: 'allerschema 1/8/2019 17:19'!
buildQueryBlockFrom: aText
	^ OpalCompiler new
		source: '[:each |',aText,']';
		logged: false;
		evaluate! !

!HWMooseQueryHandler methodsFor: 'as yet unclassified' stamp: 'allerschema 1/8/2019 17:22'!
executeQueryBlock: aBlock on: aFamixClassGroup
	^aFamixClassGroup collect: aBlock ! !

!HWMooseQueryHandler methodsFor: 'as yet unclassified' stamp: 'allerschema 1/8/2019 17:21'!
executeQueryWith: aText on: aFamixClassGroup
	^ self executeQueryBlock: (self buildQueryBlockFrom: aText) on: aFamixClassGroup! !

Object subclass: #HWRoassalDrawer
	instanceVariableNames: 'elements selected name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWRoassalDrawer commentStamp: 'test 12/21/2018 16:05' prior: 0!
Responsible for drawing a Roassal view in the HWMainPresenter

It knows the list of elements that the HWMainPresenter is showing, and the element in this list that is selected.
It is responsible to show this element in some way!

HWRoassalDrawer subclass: #HWDrawerMethodsImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerMethodsImplementors commentStamp: 'allerschema 12/27/2018 14:28' prior: 0!
I am in charge of drawing a selector implemetors!

!HWDrawerMethodsImplementors class methodsFor: 'drawing' stamp: 'allerschema 1/7/2019 15:46'!
isApplicableOn: aType
^aType isSymbol ! !

!HWDrawerMethodsImplementors methodsFor: 'drawing' stamp: 'allerschema 1/7/2019 15:46'!
drawOnRoassalView: aView
	| shape |
	shape := RTBox new
		size: 50;
		color: Color gray trans.
	elements := shape elementsOn: self selected senders.
	aView addAll: elements.
	elements @ RTPopup.
	RTFlowLayout on: elements.
	! !

HWRoassalDrawer subclass: #HWDrawerSubclassesWithForceLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerSubclassesWithForceLayout class methodsFor: 'drawing' stamp: 'allerschema 1/7/2019 15:46'!
isApplicableOn: aType
	^aType isClass
! !

!HWDrawerSubclassesWithForceLayout methodsFor: 'drawing' stamp: 'CyrilFerlicot 1/7/2019 14:53'!
drawOnRoassalView: roassalView
	| es |
	roassalView @ RTDraggableView.
	es := (RTEllipse new
		size: 15;
		color: [ :c | 
			c = selected
				ifTrue: [ Color green ]
				ifFalse: [ Color black alpha: 0.5 ] ]) elementsOn: selected withAllSubclasses.
	roassalView addAll: es.
	es @ RTDraggable @ RTPopup.
	RTEdgeBuilder new
		view: roassalView;
		elements: es;
		connectFrom: #superclass.
	RTForceBasedLayout new on: es! !

HWRoassalDrawer subclass: #HWDrawerSuperclassesWithTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerSuperclassesWithTreeLayout class methodsFor: 'drawing' stamp: 'allerschema 1/7/2019 15:46'!
isApplicableOn: aType
^aType isClass ! !

!HWDrawerSuperclassesWithTreeLayout methodsFor: 'drawing' stamp: 'CyrilFerlicot 1/7/2019 14:53'!
drawOnRoassalView: roassalView
	| es |
	roassalView @ RTDraggableView.
	es := (RTEllipse new
		size: 15;
		color: [ :c | 
			c = selected
				ifTrue: [ Color green ]
				ifFalse: [ Color black alpha: 0.5 ] ]) elementsOn: selected withAllSuperclasses.
	roassalView addAll: es.
	es @ RTDraggable @ RTPopup.
	RTEdgeBuilder new
		view: roassalView;
		elements: es;
		connectFrom: #superclass.
	RTTreeLayout new on: es! !

!HWRoassalDrawer class methodsFor: 'drawing' stamp: 'allerschema 1/7/2019 15:45'!
isApplicableOn: aType
	self subclassResponsibility! !

!HWRoassalDrawer methodsFor: 'drawing' stamp: 'test 12/21/2018 16:08'!
drawOnRoassalView: aView
	self subclassResponsibility! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
elements
	^ elements! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
elements: anObject
	elements := anObject! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
selected
	^ selected! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
selected: anObject
	selected := anObject! !

Object subclass: #MSELoader
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version2'!

!MSELoader commentStamp: 'allerschema 1/2/2019 16:40' prior: 0!
I'm responsable of loading mse files!

!MSELoader methodsFor: 'initialization' stamp: 'allerschema 1/2/2019 16:40'!
initialize 
super initialize .
model:=MooseModel new.! !

!MSELoader methodsFor: 'utilities' stamp: 'allerschema 1/8/2019 15:27'!
loadMSE
	| fileRef |
	fileRef := UIManager default
		chooseExistingFileReference: 'Import model from MSE file'
		extensions: #('mse')
		path: ''
		preview: ''.
	fileRef isNotNil
		ifTrue: [  ^ MooseModel new importFromMSEStream: fileRef asFileReference readStream ]! !

!MSELoader methodsFor: 'accessing' stamp: 'allerschema 1/2/2019 16:41'!
model
	^ model! !

!MSELoader methodsFor: 'accessing' stamp: 'allerschema 1/2/2019 16:41'!
model: anObject
	model := anObject! !

DynamicComposablePresenter subclass: #DrawerOptions
	instanceVariableNames: 'typeLabel selectedDrawer drawerList config buttonOk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version2'!

!DrawerOptions commentStamp: 'allerschema 1/3/2019 12:01' prior: 0!
I am a Modal to allow user to select a draw beyond different options!

!DrawerOptions class methodsFor: 'specs' stamp: 'allezschema 1/5/2019 19:30'!
defaultSpec
	^ SpecColumnLayout composed
		newRow: [ :r1 | r1 add: #typeLabel ] origin: 0 @ 0 corner: 1 @ 0.2;
		newRow: [ :r2 | r2 add: #drawerList ] origin: 0 @ 0.2 corner: 1 @ 0.4;
		add: #buttonOk height: 30;
		yourself! !

!DrawerOptions class methodsFor: 'specs' stamp: 'allerschema 1/4/2019 15:13'!
runMe
<script>
DrawerOptions new openWithSpec ! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allezschema 1/5/2019 13:49'!
buttonOk
	^ buttonOk! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allezschema 1/3/2019 21:26'!
config
	^ config! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allezschema 1/3/2019 21:26'!
config: anObject
	config := anObject! !

!DrawerOptions methodsFor: 'api' stamp: 'allerschema 1/4/2019 14:43'!
drawerList
	^ drawerList! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allerschema 1/4/2019 14:43'!
drawerList: anObject
	drawerList := anObject! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allezschema 1/5/2019 14:03'!
initButtonOk
	buttonOk := self newButton.
	buttonOk label: 'Draw'! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allerschema 1/4/2019 16:05'!
initConfig
	config := self instantiateDrawConfig! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allezschema 1/5/2019 01:23'!
initConfigWith: aType
	config := self instantiateDrawConfigWith: aType! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allezschema 1/6/2019 15:15'!
initDrawerList
	drawerList := self
		newDropList.
	"Select a drawer for ' , config type printString."
	self
		drawerList
		
			items:
			self
				config
				applicableDrawers
				asOrderedCollection;
		
			whenSelectedItemChanged:
				[ :item | 
			config selectedDrawer: item
				new ]! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allerschema 1/4/2019 17:08'!
initTypeLabel
	typeLabel := self newLabel.
	"typeLabel label: text"! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allezschema 1/5/2019 18:09'!
initializeWidgets
	self initConfig.
	self initDrawerList.
	self initTypeLabel.
	self initButtonOk.
	self focusOrder
		add: typeLabel;
		add: drawerList;
		add: buttonOk! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allerschema 1/4/2019 16:05'!
instantiateDrawConfig
	^ DrawConfig new ! !

!DrawerOptions methodsFor: 'initialization' stamp: 'allerschema 1/4/2019 16:17'!
instantiateDrawConfigWith: aType
	^ DrawConfig new type: aType! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allezschema 1/5/2019 14:19'!
selectedDrawer
	^ selectedDrawer! !

!DrawerOptions methodsFor: 'api' stamp: 'allezschema 1/5/2019 19:23'!
title 
^'Drawing options'! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allezschema 1/3/2019 21:26'!
typeLabel
	^ typeLabel! !

!DrawerOptions methodsFor: 'accessing' stamp: 'allezschema 1/3/2019 21:26'!
typeLabel: anObject
	typeLabel := anObject! !

ComposablePresenter subclass: #HWMainPresenter
	instanceVariableNames: 'eltsWidget diagram drawer menu drawerOptions buttonOk'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWMainPresenter commentStamp: 'allerschema 12/28/2018 11:37' prior: 0!
REsponsible for opening a window with a list of elements on the left and a Roassal diagram on the right.
Selecting an elements in the list on the left will trigger a refresh of the roassal view on the right

[[[
			(HWMainPresenter withDrawer: HWDrawerSubclassesWithForceLayout) openWithSpec 
]]]

I'm able to performe choice making depending on what is selected.
Exemple:
-runMe
- Select item and right click
	.if entity is a method the only methods visualisation are enabled.!

!HWMainPresenter class methodsFor: 'specs' stamp: 'allerschema 1/8/2019 13:57'!
defaultSpec
	^ SpecColumnLayout composed
		newRow: [ :r | r add: #menu ] height: self toolbarHeight;
		newRow:
			[ :r | 
			r
				newColumn: [ :c | c add: #eltsWidget ] left: 0 right: 0.7;
				newColumn: [ :c | c add: #diagram ] right: 0 ] yourself! !

!HWMainPresenter class methodsFor: 'specs' stamp: 'allerschema 1/7/2019 15:57'!
drawSpec
	<spec: #default>
	^ SpecLayout composed
		newColumn: [ :tcol | 
			tcol
				newRow: [ :trow | 
					trow
						newColumn: [ :left | 
							left
								add: #menu height: self toolbarHeight;
								add: #eltsWidget left: 0 right: 0.6 ]
						width: 400.
					trow newColumn: [ :right | right add: #diagram ] ] ];
		yourself! !

!HWMainPresenter class methodsFor: 'example' stamp: 'allerschema 1/8/2019 14:10'!
runMeWithClass
	<script>
	| col |
	col := OrderedCollection new.
	col add: #put.
	col
		add: IceTipMergePatchMorph;
		add: OrderedCollection.
	(self withDrawer: HWDrawerSubclassesWithForceLayout elements: Object withAllSubclasses)
		openWithSpec! !

!HWMainPresenter class methodsFor: 'example' stamp: 'allerschema 1/8/2019 14:11'!
runMeWithSelectors
	<script>
	(HWMainPresenter withDrawer: HWDrawerMethodsImplementors elements: Object allSelectors)
		openWithSpec! !

!HWMainPresenter class methodsFor: 'instance creation' stamp: 'allerschema 1/8/2019 14:03'!
withDrawer: aDrawerClass elements: aCollection
	^ self basicNew
		initialize;
		eltList: aCollection;
		yourself! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allerschema 1/7/2019 16:03'!
actionButtonOkClick
	| elt |
	drawer := self currentConfig selectedDrawer.
	elt := self eltsWidget eltList selectedItem.
	drawer isNotNil
		ifFalse: [ ^ self ].
	drawer selected: elt.
	self needRebuild: false.
	self drawOnViewWith: drawer.
	self buildWithSpecLayout: self class drawSpec.
	self eltsWidget eltList setSelectedItem: elt.
	
	self drawerOptions window close! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allezschema 1/6/2019 15:17'!
currentConfig
	^ self drawerOptions config! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 12/29/2018 13:46'!
defaultView
	| cm |
	cm := self newLabel.
	cm label: 'Right click on an element from the list and choose visualization please.'.
	^ cm! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 15:05'!
diagram
	^ diagram! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allerschema 1/4/2019 15:45'!
diagram: anObject
	diagram := anObject! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allerschema 1/7/2019 16:16'!
drawOnViewWith: aDrawerInstance
	diagram := self instantiate: RoassalModel.
	diagram
		script: [ :view :canvas | 
			aDrawerInstance drawOnRoassalView: view.
			 ]! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allerschema 1/4/2019 15:45'!
drawerOptions
	^ drawerOptions! !

!HWMainPresenter methodsFor: 'api' stamp: 'allerschema 1/7/2019 15:57'!
eltList
	^self eltsWidget eltList! !

!HWMainPresenter methodsFor: 'api' stamp: 'allerschema 1/7/2019 15:57'!
eltList: aCollection
	self eltsWidget eltList: aCollection! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allerschema 1/7/2019 15:58'!
eltsWidget
	^ eltsWidget! !

!HWMainPresenter methodsFor: 'api' stamp: 'allerschema 1/7/2019 16:42'!
extent
	^ 800 @ 650! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 1/7/2019 09:20'!
initializePresenter
	
	self drawerOptions buttonOk action: [ self actionButtonOkClick ]! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 1/7/2019 15:58'!
initializeWidgets
	eltsWidget:= self instantiate: ListWidget.
	drawerOptions := DrawerOptions new.
	self eltList
		menu: [ :aMenu | 
			MenuPresenter new
				addGroup: [ :group | group addMenuItem: self visualizationMenuItem ];
				buildWithSpecAsPopup ].
	menu := self mainMenu.
	menu applyTo: self.
	self eltList: #().
	diagram := self defaultView.
	self focusOrder
		add: menu;
		add: eltsWidget;
		add: diagram! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 1/8/2019 15:44'!
loadImportedModel
	self eltList: (MSELoader new loadMSE) allModelClasses ! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 1/8/2019 15:40'!
mainMenu
	| aMenu |
	aMenu := MenuPresenter
		new
		
			addGroup:
				[ :group | 
			group
				addItem:
					[ :item | 
					item
						
							name:
							'File';
						
							icon:
							(self
								iconNamed:
									#openIcon) ].
			group
				addItem:
					[ :item | 
					item
						
							name: nil;
						
							description:
							'Open file';
						
							icon:
							(self
								iconNamed:
									#openIcon);
						
							action:
								[ self loadImportedModel ] ].
			group
				addItem:
					[ :item | 
					item
						
							name: nil;
						
							description:
							'Save File';
						
							icon:
							(self
								iconNamed:
									#smallSaveIcon);
						
							action:
								[ self
								inform:
									'Save File' ] ].
			group
				addItem:
					[ :item | 
					item
						
							name: nil;
						
							description:
							'Print file';
						
							icon:
							(self
								iconNamed:
									#smallPrintIcon);
						
							action:
								[ self
								inform:
									'Print file' ] ] ];
		
			addGroup:
				[ :group | 
			group
				addItem:
					[ :item | 
					item
						
							name: nil;
						
							description:
							'Undo';
						
							icon:
							(self
								iconNamed:
									#smallUndoIcon);
						
							action:
								[ self
								inform:
									'Undo' ] ].
			group
				addItem:
					[ :item | 
					item
						
							name: nil;
						
							description:
							'Redo';
						
							icon:
							(self
								iconNamed:
									#smallRedoIcon);
						
							action:
								[ self
								inform:
									'Redo' ] ] ].
	^ aMenu! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allezschema 12/23/2018 03:42'!
menu
	^ menu! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'allezschema 12/23/2018 03:42'!
menu: anObject
	menu := anObject! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allerschema 1/8/2019 14:04'!
runMeWithClass
	<script>
	| col |
	col := OrderedCollection new.
	col add: #put.
	col
		add: IceTipMergePatchMorph;
		add: OrderedCollection.
	(self withDrawer: HWDrawerSubclassesWithForceLayout elements: col)
		openWithSpec! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allerschema 1/8/2019 14:04'!
runMeWithSelectors
	<script>
	(self withDrawer: HWDrawerMethodsImplementors elements: Object allSelectors)
		openWithSpec! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allezschema 12/23/2018 03:29'!
title 
^'Visualization'.! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allerschema 1/7/2019 15:57'!
visualizationMenuItem
	"Serve to refactor adding an item to my context menu. Goal: avoid having brain method. Thus I reduce the LOC of initializeWidgets  "

	^ MenuItemPresenter new
		name: 'Visualize';
		action: [ 
			self visualizeOptionsOn: (self eltsWidget eltList  selectedItem)];
		yourself! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'allerschema 1/7/2019 16:07'!
visualizeOptionsOn: item
	self drawerOptions
		initConfigWith: item;
		initDrawerList.
	self drawerOptions typeLabel label: item printString.
	self drawerOptions openWithSpec.
	self drawerOptions window modalRelativeTo: World! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allerschema 1/8/2019 13:59'!
withDrawer: aDrawerClass
	^self basicNew
		withDrawer: aDrawerClass new;
		initialize ;
		yourself! !

!HWMainPresenter methodsFor: 'utilities' stamp: 'allerschema 1/8/2019 13:58'!
withDrawer: aDrawerClass elements: aCollection
	^ self basicNew
		initialize;
		eltList: aCollection;
		yourself! !

ComposablePresenter subclass: #ListWidget
	instanceVariableNames: 'eltList filtre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!ListWidget commentStamp: 'allezschema 12/22/2018 15:55' prior: 0!
I contain the list of elements and the filter!

!ListWidget class methodsFor: 'overrides' stamp: 'allerschema 1/3/2019 14:50'!
defaultSpec
	| filtreHeight |
	filtreHeight := StandardFonts defaultFont height + 15.
	^ SpecLayout composed
		add: #eltList origin: 0 @ 0.05 corner: 1 @ 1;
		add: #filtre
			origin: 0 @ 0
			corner: 1 @ 0
			offsetOrigin: 0 @ 0
			offsetCorner: 0 @ filtreHeight;
		yourself! !

!ListWidget methodsFor: 'api' stamp: 'allezschema 1/3/2019 23:53'!
eltList
	^ eltList! !

!ListWidget methodsFor: 'api' stamp: 'allerschema 1/7/2019 09:22'!
eltList: aCollection
	eltList
		items: aCollection.! !

!ListWidget methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 15:52'!
filter: aCollection with: aText

	^aCollection
		select: [ :cl | 
			(cl name matchesRegex: aText , '.*')
				 ].
	! !

!ListWidget methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 12:25'!
filtre
	^ filtre! !

!ListWidget methodsFor: 'overrides' stamp: 'allezschema 1/3/2019 23:52'!
initializePresenter
	filtre
		whenTextChanged: [ :text | 
			text = ''
				ifFalse: [ eltList items: (self filter: self eltList listItems with: text , '.*') ]
				ifTrue: [ eltList items: (Object allSubclasses sort: [ :a :b | a name < b name ]) ] ]! !

!ListWidget methodsFor: 'overrides' stamp: 'allezschema 1/6/2019 16:12'!
initializeWidgets
	eltList := self newList.
	
	filtre := self newTextInput.
	"listClass items: (Object allSubclasses sort: [ :a :b | a name < b name ])."
	filtre
		ghostText: 'Enter a class name';
		autoAccept: true;
		removeEntryCompletion.
	self focusOrder
		add: eltList;
		add: filtre! !

!ListWidget methodsFor: 'api' stamp: 'allerschema 1/3/2019 14:52'!
onEltSelected: aBlock
	self eltList whenSelectedItemChanged: aBlock! !

!ListWidget methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:54'!
title
^'Listes des classes'! !

TestCase subclass: #WidgetClassListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-tests'!

!WidgetClassListTest methodsFor: 'event testing' stamp: 'allerschema 1/3/2019 14:49'!
testFilter
	"Je permet de test filtre d'une liste "

	self assert: ((ListWidget new filter: OrderedCollection allSubclasses with: 'GL') at: 1) equals: GLMMultiValue! !
